<pre>
<?php
class Address {
	public $address1;
	public $address2;
	public $city;
	public $state;
	public $zip;
	
	public function __construct( $add1, $add2, $city, $state, $zip ) {
		$this->address1 = $add1;
		$this->address2 = $add2;
		$this->city = $city;
		$this->state = $state;
		$this->zip = $zip;
	}
	
	public function formatAddress() {
		$fmtAddress = '<p class="addr">' . $this->address1;
		if (trim($this->address2) != '') {
			$fmtAddress .= "\n{$this->address2}";
		}
		$fmtAddress .= "\n{$this->city}, {$this->state} {$this->zip}";
		$fmtAddress .= '</p>';		
		return $fmtAddress;
	}
}

//------------------------------------------------------------------------
class Person {
	protected $name;
	protected $homeAddress; // Address object
	protected $dateOfBirth;
	
	// Functions (i.e.: methods)
	public function __construct( $name ) {
		$this->name = $name;
	}
	public function getName() {
		return $this->name;
	}
	public function setHomeAddress($add1, $add2, $city, $state, $zip) {
		$this->homeAddress = new Address($add1, $add2, $city, $state, $zip);
	}
	public function getHomeAddress() {
		return $this->homeAddress;
	}
	public function show() {
		echo '<span class="show">';
		echo "Hello. My name is {$this->name}.<br></span>";
	}
}
 
//------------------------------------------------------------------------
class Employee extends Person {
	protected $dateOfHire;
	protected $employmentStatus;
	protected $payScale;
	
	public function __construct($name, $dateOfHire) {
		parent::__construct($name);
		$this->dateOfHire = $dateOfHire;
	}
	
	public function show() {
		parent::show();
		echo '<span class="show">';
		echo "I was hired on {$this->dateOfHire}<br></span>";
	}
}
 
//------------------------------------------------------------------------
class Customer extends Person {
	protected $dateOfFirstOrder;
	protected $creditStatus;
	protected $billingAddress; // Address object

	public function setBillingAddress($add1, $add2, $city, $state, $zip) {
		$this->billingAddress = new Address($add1, $add2, $city, $state, $zip);
	}
	public function getBillingAddress() {
		return $this->billingAddress;
	}
}
?>
<style>
.show { color:blue; font-weight:bold; font-family:arial; margin-bottom: 8px }
.addr { color:green; font-weight:bold; font-family:arial; padding-top: 0px;  }
h3 { color: navy; font-size: 1.1em; font-family: verdana; padding-top: 4px; margin-bottom: 0px; text-decoration: underline }
</style>
<?php 
//------------------------------------------------------------------------
$bob = new Person('Bob Smith');
$bob->setHomeAddress('123 Main St.', '', 'Burlington', 'VT', '05401');
$bob->show();

var_dump($bob);

echo "<h3>Bob's home address:</h3>";
echo $bob->getHomeAddress()->formatAddress();
echo '<hr>';

//------------------------------------------------------------------------
$jane = new Employee('Jane Doe', 'Dec 16, 2005');
$jane->show();

var_dump($jane);
echo '<hr>';

//------------------------------------------------------------------------
$sue = new Customer('Sue Jackson');
$sue->setHomeAddress('1809 Sunny Blvd.', 'Apt. 2', 'Jericho', 'VT', '05465');
$sue->setBillingAddress('73-15 67th Ave.', 'Box 315', 'Winooski', 'VT', '05405');

$sue->show();
var_dump($sue);

echo "<h3>Sue's home address:</h3>";
echo $sue->getHomeAddress()->formatAddress();

echo "<h3>Sue's billing address:</h3>";
echo $sue->getBillingAddress()->formatAddress();

?>
</pre>