<pre>
<?php
/* Copyright (C) 2016 John Valance - All Rights Reserved.
 You may use, distribute and modify this code under the
 terms of the BSD license. See file LICENSE.txt in the
 top-most parent folder distributed with this source code.
 If missing, please write to: johnv@div1sys.com.
 */
require_once 'Person_RDG.php';
require_once 'PersonFinder.php';

// Start with empty table
//Person_RDG::delete_all();

$bob = new Person_RDG();
$bob->setFirstName('Bob');
$bob->setLastName('Smith');
try {
    $bob->save();  // error - no dateofbirth set
} catch (Exception $e) {
    echo '<br>Exception caught on save() operation: '.$e->getMessage();
}

$bob->setDateOfBirth('1975-08-13');
$bob->save();

$tom = new Person_RDG();
$tom->setFirstName('Tom');
$tom->setLastName('Jones');
$tom->setDateOfBirth('1969-11-02');
$tom->save();

echo "<h3>After INSERTs:</h3>";
echo '<br>$bob: <br>' . $bob;
echo '<br>$tom: <br>' . $tom;


//------------------------------------------------------------
// Update rows in person table
$tom->setFirstName('Thomas');
$tom->update();

$bob->setFirstName('Robert');
$bob->save();

echo "<h3>After UPDATEs:</h3>";
print_r($bob);
print_r($tom);

//------------------------------------------------------------
// Select all rows
$all_persons = PersonFinder::find_all();

echo "<h3>Use PersonFinder class to get all Persons:</h3>";

foreach ($all_persons as $person) {
    $name = getFullName($person->getFirstName(), $person->getLastName());
    echo "Person ID = {$person->getId()}: name = $name<br>";
}

//------------------------------------------------------------
// Retrieve specific row from person table
echo "<h3>Try to retrieve by IDs:</h3>";

try {
    $jack = new Person_RDG(257);
    echo '<br>Person_RDG(257):<br>' . $jack;
} catch (Exception $e) {
    echo '<br>' . $e->getMessage();
}

try {
    $jill = new Person_RDG();
    $jill->find(3);
    echo '<br>Person_RDG(3):<br>' . $jill;
} catch (Exception $e) {
    echo '<br>' . $e->getMessage();
}


//------------------------------------------------------------
// Calculate Bob's age

$bobsName = getFullName($bob->getFirstName(), $bob->getLastName());
$bobsBDayFmtd = formatBirthDate($bob->getDateOfBirth());
$bobsAge = calculateAge($bob->getDateOfBirth());
echo "<h3>Calculate Age:</h3>";
echo "$bobsName was born on $bobsBDayFmtd, and his age is $bobsAge";

//------------------------------------------------------------
// Delete specific row from person table
echo "<h3>DELETE \$tom:</h3>";

$tom->delete();
unset($tom);
echo '$tom after delete() and unset(): <br>' . $tom;


echo "<h3>END of Script!</h3>";

//------------------------------------------------------------
// LOCAL FUNCTIONS
//------------------------------------------------------------

function getFullNameObj( $pers ) {
    return $pers->getFirstName() . ' ' . $pers->getLastName();
}

function getFullName( $first, $last ) {
    return $first . ' ' . $last;
}

function formatBirthDate( $dateStr ) {
    return date('D M d, Y', strtotime($dateStr));
}

function calculateAge( $dateStr ) {
    $datetime1 = new DateTime(date('Ymd'));
    $datetime2 = new DateTime($dateStr);
    $interval = $datetime2->diff($datetime1);
    return $interval->format('%r%y years, %m months, %d days');
}

?>
</pre>
