<?php 

// send email
//   through SMTP (exchange or other)
//   with an attachment
// Use Zend\Mail component of Zend Framework 2

// show errors on the screen while testing ONLY
ini_set('display_errors', 1);

use Zend\Mime;
use Zend\Mail\Message;
use Zend\Mail\Transport\Smtp as SmtpTransport;
use Zend\Mail\Transport\SmtpOptions;


function send($subject, $body, $filename = '', $mimeType = 'text/html') {


    // TODO get these from a configuration file
    $smtpHost = 'smtp.myserver.com';
    $smtpUser = 'fred';
    $smtpPass = 'fredspw';
    $emailTo = 'me@myserver.com';
    $emailFrom = 'someone@myserver.com';

    // TODO you may also want to change the SSL and port settings near the end of this script.


	// Either update php's include_path to reflect ZF2 not ZF1
	// or set it here, like so:
	$path = '/usr/local/zendsvr6/share/ZendFramework2/library';
	set_include_path( $path . PATH_SEPARATOR . get_include_path());
	
	// http://framework.zend.com/manual/2.0/en/modules/zend.mail.message.html
	
	// (Assumes you have a recent version of Zend Server or downloaded Zend Framework 2)
	
	require_once 'Zend/Loader/StandardAutoloader.php';
	$loader = new Zend\Loader\StandardAutoloader(array('autoregister_zf' => true));
	$loader->register();
	
	
	$pathToAttachment = $filename;
		
	$email = $emailTo;
	$from = $emailFrom;
	
	// create a new Zend\Mail\Message object
	$message  = new Message;
	
	// create a MimeMessage object that will hold the mail body and any attachments
	$bodyPart = new Mime\Message;
	
	// create the mime part for the message body
	// you can add one for text and one for html if needed
	$bodyMessage = new Mime\Part($body);
	$bodyMessage->type = 'text/html';
	
	
    // create the attachment
    $attachment = new Mime\Part(fopen($pathToAttachment, 'r'));
	
    // set attachment content type
    $attachment->type = $mimeType;
    $attachment->filename = basename($pathToAttachment);

    // if a binary object such as an image, use base 64 encoding.
    if (stripos($mimeType, 'image') !== false || stripos($mimeType, 'pdf') !== false) {
        $attachment->encoding = Zend\Mime\Mime::ENCODING_BASE64;
    }
    
    // add the message body and attachment(s) to the MimeMessage
    $bodyPart->setParts(array($bodyMessage, $attachment));
	     
	
	$message->setEncoding('utf-8')
	->setTo($email)
	//->setReplyTo($replyTo)
	->setFrom($from)
	->setSubject($subject)
	->setBody($bodyPart);  // set the body of the Mail to the MimeMessage with the mail content and attachment
		
	// Setup SMTP transport using LOGIN authentication
	$transport = new SmtpTransport();
	$options   = new SmtpOptions(array(
	    'name'              => $smtpHost,
	    'host'              => $smtpHost,
		
	    'port'              => 465,
	    'connection_class'  => 'login',
	    'connection_config' => array(
	        'username' => $smtpUser,
	        'password' => $smtpPass,
	    		'ssl'               => 'ssl',
	    		
	    ),
	));
	
	$transport->setOptions($options);
	
	try {
	    $transport->send($message);
	    return true;
	} catch (Exception $e) {
	     return false;
	}
} //(function send)
